Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34921)
@@ -35,7 +35,14 @@
 #              23) MetaMorph Stack (STK) Image File Format:
 #                  --> ftp://ftp.meta.moleculardevices.com/support/stack/STK.doc
-#              24) http://www.cipa.jp/english/hyoujunka/kikaku/pdf/DC-008-2010_E.pdf (Exif 2.3)
+#              24) http://www.cipa.jp/std/documents/e/DC-008-2012_E.pdf (Exif 2.3)
 #              25) Vesa Kivisto private communication (7D)
 #              26) Jeremy Brown private communication
+#              27) Gregg Lee private communication
+#              28) http://wwwimages.adobe.com/www.adobe.com/content/dam/Adobe/en/devnet/cinemadng/pdfs/CinemaDNG_Format_Specification_v1_1.pdf
+#              29) http://www.libtiff.org
+#              30) http://geotiff.maptools.org/spec/geotiffhome.html
+#              31) https://android.googlesource.com/platform/external/dng_sdk/+/refs/heads/master/source/dng_tag_codes.h
+#              32) Jeffry Friedl private communication
+#              IB) Iliah Borg private communication (LibRaw)
 #              JD) Jens Duttke private communication
 #------------------------------------------------------------------------------
@@ -46,9 +53,9 @@
 use vars qw($VERSION $AUTOLOAD @formatSize @formatName %formatNumber %intFormat
             %lightSource %flash %compression %photometricInterpretation %orientation
-            %subfileType);
+            %subfileType %saveForValidate);
 use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::MakerNotes;
 
-$VERSION = '3.21';
+$VERSION = '4.33';
 
 sub ProcessExif($$$);
@@ -58,7 +65,9 @@
 sub EncodeExifText($$);
 sub ValidateIFD($;$);
+sub ValidateImageData($$$;$);
 sub ProcessTiffIFD($$$);
 sub PrintParameter($$$);
 sub GetOffList($$$$$);
+sub PrintOpcode($$$);
 sub PrintLensInfo($);
 sub ConvertLensInfo($);
@@ -71,9 +80,9 @@
 
 @formatName = (
-    undef, 'int8u', 'string', 'int16u',
-    'int32u', 'rational64u', 'int8s', 'undef',
-    'int16s', 'int32s', 'rational64s', 'float',
-    'double', 'ifd', 'unicode', 'complex',
-    'int64u', 'int64s', 'ifd64', # (new BigTIFF formats)
+     undef,    'int8u',      'string',     'int16u',
+    'int32u',  'rational64u','int8s',      'undef',
+    'int16s',  'int32s',     'rational64s','float',
+    'double',  'ifd',        'unicode',    'complex',
+    'int64u',  'int64s',     'ifd64', # (new BigTIFF formats)
 );
 
@@ -88,5 +97,5 @@
     'int8s'       => 6,  # SBYTE
     'undef'       => 7,  # UNDEFINED
-    'binary'      => 7,  # (treat binary data as undef)
+    'binary'      => 7,  # (same as undef)
     'int16s'      => 8,  # SSHORT
     'int32s'      => 9,  # SLONG
@@ -204,4 +213,5 @@
     32770 => 'Samsung SRW Compressed', #PH
     32771 => 'CCIRLEW', #3
+    32772 => 'Samsung SRW Compressed 2', #PH (NX3000,NXmini)
     32773 => 'PackBits',
     32809 => 'Thunderscan', #3
@@ -213,6 +223,9 @@
     32908 => 'PixarFilm', #3
     32909 => 'PixarLog', #3
+  # 32910,32911 - Pixar reserved
     32946 => 'Deflate', #3
     32947 => 'DCS', #3
+    33003 => 'Aperio JPEG 2000 YCbCr', #https://openslide.org/formats/aperio/
+    33005 => 'Aperio JPEG 2000 RGB', #https://openslide.org/formats/aperio/
     34661 => 'JBIG', #3
     34676 => 'SGILog', #3
@@ -224,4 +237,12 @@
     34719 => 'Microsoft Document Imaging (MDI) Progressive Transform Codec', #18
     34720 => 'Microsoft Document Imaging (MDI) Vector', #18
+    34887 => 'ESRI Lerc', #LibTiff
+  # 34888,34889 - ESRI reserved
+    34892 => 'Lossy JPEG', # (DNG 1.4)
+    34925 => 'LZMA2', #LibTiff
+    34926 => 'Zstd', #LibTiff
+    34927 => 'WebP', #LibTiff
+    34933 => 'PNG', # (TIFF mail list)
+    34934 => 'JPEG XR', # (TIFF mail list)
     65000 => 'Kodak DCR Compressed', #PH
     65535 => 'Pentax PEF Compressed', #Jens
@@ -242,5 +263,7 @@
     32844 => 'Pixar LogL', #3
     32845 => 'Pixar LogLuv', #3
+    32892 => 'Sequential Color Filter', #JR (Sony ARQ)
     34892 => 'Linear Raw', #2
+    51177 => 'Depth Map', # (DNG 1.5)
 );
 
@@ -257,5 +280,5 @@
 
 %subfileType = (
-    0 => 'Full-resolution Image',
+    0 => 'Full-resolution image',
     1 => 'Reduced-resolution image',
     2 => 'Single page of multi-page image',
@@ -265,4 +288,8 @@
     6 => 'Transparency mask of multi-page image',
     7 => 'Transparency mask of reduced-resolution multi-page image',
+    8 => 'Depth map', # (DNG 1.5)
+    9 => 'Depth map of reduced-resolution image', # (DNG 1.5)
+    16 => 'Enhanced image data', # (DNG 1.5)
+    0x10001 => 'Alternate reduced-resolution image', # (DNG 1.2)
     0xffffffff => 'invalid', #(found in E5700 NEF's)
     BITMASK => {
@@ -270,6 +297,6 @@
         1 => 'Single page',
         2 => 'Transparency mask',
-        3 => 'TIFF/IT final page', #20
-        4 => 'TIFF-FX mixed raster content', #20
+        3 => 'TIFF/IT final page', #20 (repurposed as DepthMap repurposes by DNG 1.5)
+        4 => 'TIFF-FX mixed raster content', #20 (repurposed as EnhancedImageData by DNG 1.5)
     },
 );
@@ -281,4 +308,12 @@
         OTHER => \&Image::ExifTool::Exif::PrintParameter,
     },
+);
+
+# convert DNG UTF-8 string values (may be string or int8u format)
+my %utf8StringConv = (
+    Writable => 'string',
+    Format => 'string',
+    ValueConv => '$self->Decode($val, "UTF8")',
+    ValueConvInv => '$self->Encode($val,"UTF8")',
 );
 
@@ -299,8 +334,45 @@
 );
 
+# save the values of these tags for additional validation checks
+%saveForValidate = (
+    0x100 => 1, # ImageWidth
+    0x101 => 1, # ImageHeight
+    0x102 => 1, # BitsPerSample
+    0x103 => 1, # Compression
+    0x115 => 1, # SamplesPerPixel
+);
+
+# conversions for DNG OpcodeList tags
+my %opcodeInfo = (
+    Writable => 'undef',
+    WriteGroup => 'SubIFD',
+    Protected => 1,
+    Binary => 1,
+    ConvertBinary => 1, # needed because the ValueConv value is binary
+    PrintConvColumns => 2,
+    PrintConv => {
+        OTHER => \&PrintOpcode,
+        1 => 'WarpRectilinear',
+        2 => 'WarpFisheye',
+        3 => 'FixVignetteRadial',
+        4 => 'FixBadPixelsConstant',
+        5 => 'FixBadPixelsList',
+        6 => 'TrimBounds',
+        7 => 'MapTable',
+        8 => 'MapPolynomial',
+        9 => 'GainMap',
+        10 => 'DeltaPerRow',
+        11 => 'DeltaPerColumn',
+        12 => 'ScalePerRow',
+        13 => 'ScalePerColumn',
+    },
+    PrintConvInv => undef,  # (so the inverse conversion is not performed)
+);
+
 # main EXIF tag table
 %Image::ExifTool::Exif::Main = (
     GROUPS => { 0 => 'EXIF', 1 => 'IFD0', 2 => 'Image'},
     WRITE_PROC => \&WriteExif,
+    CHECK_PROC => \&CheckExif,
     WRITE_GROUP => 'ExifIFD',   # default write group
     SET_GROUP1 => 1, # set group1 name to directory name for all tags in table
@@ -308,4 +380,7 @@
         Name => 'InteropIndex',
         Description => 'Interoperability Index',
+        Protected => 1,
+        Writable => 'string',
+        WriteGroup => 'InteropIFD',
         PrintConv => {
             R98 => 'R98 - DCF basic file (sRGB)',
@@ -317,12 +392,22 @@
         Name => 'InteropVersion',
         Description => 'Interoperability Version',
+        Protected => 1,
+        Writable => 'undef',
+        Mandatory => 1,
+        WriteGroup => 'InteropIFD',
         RawConv => '$val=~s/\0+$//; $val',  # (some idiots add null terminators)
     },
     0x0b => { #PH
         Name => 'ProcessingSoftware',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
         Notes => 'used by ACD Systems Digital Imaging',
     },
     0xfe => {
         Name => 'SubfileType',
+        Notes => 'called NewSubfileType by the TIFF specification',
+        Protected => 1,
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
         # set priority directory if this is the full resolution image
         DataMember => 'SubfileType',
@@ -332,4 +417,8 @@
     0xff => {
         Name => 'OldSubfileType',
+        Notes => 'called SubfileType by the TIFF specification',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         # set priority directory if this is the full resolution image
         RawConv => '$self->SetPriorityDir() if $val eq "1"; $val',
@@ -345,6 +434,9 @@
         # so it will show up in the group lists
         Groups => { 1 => 'IFD1' },
+        Protected => 1,
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
         # Note: priority 0 tags automatically have their priority increased for the
-        # priority direcory (the directory with a SubfileType of "Full-resolution image")
+        # priority directory (the directory with a SubfileType of "Full-resolution image")
         Priority => 0,
     },
@@ -352,12 +444,23 @@
         Name => 'ImageHeight',
         Notes => 'called ImageLength by the EXIF spec.',
+        Protected => 1,
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
         Priority => 0,
     },
     0x102 => {
         Name => 'BitsPerSample',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Count => -1, # can be 1 or 3: -1 means 'variable'
         Priority => 0,
     },
     0x103 => {
         Name => 'Compression',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Mandatory => 1,
         DataMember => 'Compression',
         SeparateTable => 'Compression',
@@ -371,4 +474,7 @@
     0x106 => {
         Name => 'PhotometricInterpretation',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => \%photometricInterpretation,
         Priority => 0,
@@ -376,4 +482,7 @@
     0x107 => {
         Name => 'Thresholding',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => {
             1 => 'No dithering or halftoning',
@@ -382,8 +491,21 @@
         },
     },
-    0x108 => 'CellWidth',
-    0x109 => 'CellLength',
+    0x108 => {
+        Name => 'CellWidth',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+    },
+    0x109 => {
+        Name => 'CellLength',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+    },
     0x10a => {
         Name => 'FillOrder',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => {
             1 => 'Normal',
@@ -391,7 +513,13 @@
         },
     },
-    0x10d => 'DocumentName',
+    0x10d => {
+        Name => 'DocumentName',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+    },
     0x10e => {
         Name => 'ImageDescription',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
         Priority => 0,
     },
@@ -399,4 +527,6 @@
         Name => 'Make',
         Groups => { 2 => 'Camera' },
+        Writable => 'string',
+        WriteGroup => 'IFD0',
         DataMember => 'Make',
         # remove trailing blanks and save as an ExifTool member variable
@@ -411,4 +541,6 @@
         Description => 'Camera Model Name',
         Groups => { 2 => 'Camera' },
+        Writable => 'string',
+        WriteGroup => 'IFD0',
         DataMember => 'Model',
         # remove trailing blanks and save as an ExifTool member variable
@@ -429,7 +561,9 @@
         },
         {
+            # (APP1 IFD2 is for Leica JPEG preview)
             Condition => q[
-                ($$self{TIFF_TYPE} ne 'CR2' or $$self{DIR_NAME} ne 'IFD0') and
-                ($$self{TIFF_TYPE} ne 'DNG' or $$self{DIR_NAME} !~ /^SubIFD[12]$/)
+                not ($$self{TIFF_TYPE} eq 'CR2' and $$self{DIR_NAME} eq 'IFD0') and
+                not ($$self{TIFF_TYPE} =~ /^(DNG|TIFF)$/ and $$self{Compression} eq '7' and $$self{SubfileType} ne '0') and
+                not ($$self{TIFF_TYPE} eq 'APP1' and $$self{DIR_NAME} eq 'IFD2')
             ],
             Name => 'StripOffsets',
@@ -439,20 +573,23 @@
         },
         {
-            Condition => '$$self{DIR_NAME} eq "IFD0"',
+            # PreviewImageStart in IFD0 of CR2 images
+            Condition => '$$self{TIFF_TYPE} eq "CR2"',
             Name => 'PreviewImageStart',
             IsOffset => 1,
             OffsetPair => 0x117,
             Notes => q{
-                PreviewImageStart in IFD0 of CR2 images and SubIFD1 of DNG images, and
-                JpgFromRawStart in SubIFD2 of DNG images
+                called StripOffsets in most locations, but it is PreviewImageStart in IFD0
+                of CR2 images and various IFD's of DNG images except for SubIFD2 where it is
+                JpgFromRawStart
             },
             DataTag => 'PreviewImage',
             Writable => 'int32u',
             WriteGroup => 'IFD0',
-            WriteCondition => '$$self{TIFF_TYPE} eq "CR2"',
             Protected => 2,
+            Permanent => 1,
         },
         {
-            Condition => '$$self{DIR_NAME} eq "SubIFD1"',
+            # PreviewImageStart in various IFD's of DNG images except SubIFD2
+            Condition => '$$self{DIR_NAME} ne "SubIFD2"',
             Name => 'PreviewImageStart',
             IsOffset => 1,
@@ -460,9 +597,10 @@
             DataTag => 'PreviewImage',
             Writable => 'int32u',
-            WriteGroup => 'SubIFD1',
-            WriteCondition => '$$self{TIFF_TYPE} eq "DNG"',
+            WriteGroup => 'All',    # (writes to specific group of associated Composite tag)
             Protected => 2,
+            Permanent => 1,
         },
         {
+            # JpgFromRawStart in various IFD's of DNG images except SubIFD2
             Name => 'JpgFromRawStart',
             IsOffset => 1,
@@ -471,10 +609,12 @@
             Writable => 'int32u',
             WriteGroup => 'SubIFD2',
-            WriteCondition => '$$self{TIFF_TYPE} eq "DNG"',
             Protected => 2,
+            Permanent => 1,
         },
     ],
     0x112 => {
         Name => 'Orientation',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => \%orientation,
         Priority => 0,  # so PRIORITY_DIR takes precedence
@@ -482,8 +622,14 @@
     0x115 => {
         Name => 'SamplesPerPixel',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         Priority => 0,
     },
     0x116 => {
         Name => 'RowsPerStrip',
+        Protected => 1,
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
         Priority => 0,
     },
@@ -501,7 +647,9 @@
         },
         {
+            # (APP1 IFD2 is for Leica JPEG preview)
             Condition => q[
-                ($$self{TIFF_TYPE} ne 'CR2' or $$self{DIR_NAME} ne 'IFD0') and
-                ($$self{TIFF_TYPE} ne 'DNG' or $$self{DIR_NAME} !~ /^SubIFD[12]$/)
+                not ($$self{TIFF_TYPE} eq 'CR2' and $$self{DIR_NAME} eq 'IFD0') and
+                not ($$self{TIFF_TYPE} =~ /^(DNG|TIFF)$/ and $$self{Compression} eq '7' and $$self{SubfileType} ne '0') and
+                not ($$self{TIFF_TYPE} eq 'APP1' and $$self{DIR_NAME} eq 'IFD2')
             ],
             Name => 'StripByteCounts',
@@ -510,28 +658,32 @@
         },
         {
-            Condition => '$$self{DIR_NAME} eq "IFD0"',
+            # PreviewImageLength in IFD0 of CR2 images
+            Condition => '$$self{TIFF_TYPE} eq "CR2"',
             Name => 'PreviewImageLength',
             OffsetPair => 0x111,
             Notes => q{
-                PreviewImageLength in IFD0 of CR2 images and SubIFD1 of DNG images, and
-                JpgFromRawLength in SubIFD2 of DNG images
+                called StripByteCounts in most locations, but it is PreviewImageLength in
+                IFD0 of CR2 images and various IFD's of DNG images except for SubIFD2 where
+                it is JpgFromRawLength
             },
             DataTag => 'PreviewImage',
             Writable => 'int32u',
             WriteGroup => 'IFD0',
-            WriteCondition => '$$self{TIFF_TYPE} eq "CR2"',
             Protected => 2,
+            Permanent => 1,
         },
         {
-            Condition => '$$self{DIR_NAME} eq "SubIFD1"',
+            # PreviewImageLength in various IFD's of DNG images except SubIFD2
+            Condition => '$$self{DIR_NAME} ne "SubIFD2"',
             Name => 'PreviewImageLength',
             OffsetPair => 0x111,
             DataTag => 'PreviewImage',
             Writable => 'int32u',
-            WriteGroup => 'SubIFD1',
-            WriteCondition => '$$self{TIFF_TYPE} eq "DNG"',
+            WriteGroup => 'All',    # (writes to specific group of associated Composite tag)
             Protected => 2,
+            Permanent => 1,
         },
         {
+            # JpgFromRawLength in SubIFD2 of DNG images
             Name => 'JpgFromRawLength',
             OffsetPair => 0x111,
@@ -539,20 +691,37 @@
             Writable => 'int32u',
             WriteGroup => 'SubIFD2',
-            WriteCondition => '$$self{TIFF_TYPE} eq "DNG"',
             Protected => 2,
+            Permanent => 1,
         },
     ],
-    0x118 => 'MinSampleValue',
-    0x119 => 'MaxSampleValue',
+    0x118 => {
+        Name => 'MinSampleValue',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+    },
+    0x119 => {
+        Name => 'MaxSampleValue',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+    },
     0x11a => {
         Name => 'XResolution',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Mandatory => 1,
         Priority => 0,  # so PRIORITY_DIR takes precedence
     },
     0x11b => {
         Name => 'YResolution',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Mandatory => 1,
         Priority => 0,
     },
     0x11c => {
         Name => 'PlanarConfiguration',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => {
             1 => 'Chunky',
@@ -561,7 +730,21 @@
         Priority => 0,
     },
-    0x11d => 'PageName',
-    0x11e => 'XPosition',
-    0x11f => 'YPosition',
+    0x11d => {
+        Name => 'PageName',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+    },
+    0x11e => {
+        Name => 'XPosition',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+    },
+    0x11f => {
+        Name => 'YPosition',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+    },
+    # FreeOffsets/FreeByteCounts are used by Ricoh for RMETA information
+    # in TIFF images (not yet supported)
     0x120 => {
         Name => 'FreeOffsets',
@@ -577,4 +760,6 @@
     0x122 => {
         Name => 'GrayResponseUnit',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => { #3
             1 => 0.1,
@@ -606,4 +791,7 @@
         Name => 'ResolutionUnit',
         Notes => 'the value 1 is not standard EXIF',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Mandatory => 1,
         PrintConv => {
             1 => 'None',
@@ -613,13 +801,25 @@
         Priority => 0,
     },
-    0x129 => 'PageNumber',
+    0x129 => {
+        Name => 'PageNumber',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Count => 2,
+    },
     0x12c => 'ColorResponseUnit', #9
     0x12d => {
         Name => 'TransferFunction',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Count => 768,
         Binary => 1,
     },
     0x131 => {
         Name => 'Software',
-        RawConv => '$val =~ s/\s+$//; $val', # trim trailing blanks
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+        DataMember => 'Software',
+        RawConv => '$val =~ s/\s+$//; $$self{Software} = $val', # trim trailing blanks
     },
     0x132 => {
@@ -627,5 +827,10 @@
         Groups => { 2 => 'Time' },
         Notes => 'called DateTime by the EXIF spec.',
+        Writable => 'string',
+        Shift => 'Time',
+        WriteGroup => 'IFD0',
+        Validate => 'ValidateExifDate($val)',
         PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,0)',
     },
     0x13b => {
@@ -633,12 +838,26 @@
         Groups => { 2 => 'Author' },
         Notes => 'becomes a list-type tag when the MWG module is loaded',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
         RawConv => '$val =~ s/\s+$//; $val', # trim trailing blanks
     },
-    0x13c => 'HostComputer',
+    0x13c => {
+        Name => 'HostComputer',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+    },
     0x13d => {
         Name => 'Predictor',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => {
             1 => 'None',
             2 => 'Horizontal differencing',
+            3 => 'Floating point', # (DNG 1.5)
+            34892 => 'Horizontal difference X2', # (DNG 1.5)
+            34893 => 'Horizontal difference X4', # (DNG 1.5)
+            34894 => 'Floating point X2', # (DNG 1.5)
+            34895 => 'Floating point X4', # (DNG 1.5)
         },
     },
@@ -646,7 +865,13 @@
         Name => 'WhitePoint',
         Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => 2,
     },
     0x13f => {
         Name => 'PrimaryChromaticities',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => 6,
         Priority => 0,
     },
@@ -656,7 +881,22 @@
         Binary => 1,
     },
-    0x141 => 'HalftoneHints',
-    0x142 => 'TileWidth',
-    0x143 => 'TileLength',
+    0x141 => {
+        Name => 'HalftoneHints',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Count => 2,
+    },
+    0x142 => {
+        Name => 'TileWidth',
+        Protected => 1,
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+    },
+    0x143 => {
+        Name => 'TileLength',
+        Protected => 1,
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+    },
     0x144 => {
         Name => 'TileOffsets',
@@ -699,5 +939,5 @@
             SubDirectory => {
                 Start => '$val',
-                MaxSubdirs => 3,
+                MaxSubdirs => 10, # (have seen 5 in a DNG 1.4 image)
             },
         },
@@ -707,9 +947,13 @@
             DataMember => 'A100DataOffset',
             RawConv => '$$self{A100DataOffset} = $val',
+            WriteGroup => 'IFD0', # (only for Validate)
             IsOffset => 1,
+            Protected => 2,
         },
     ],
     0x14c => {
         Name => 'InkSet',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => { #3
             1 => 'CMYK',
@@ -720,5 +964,9 @@
     0x14e => 'NumberofInks', #3
     0x150 => 'DotRange',
-    0x151 => 'TargetPrinter',
+    0x151 => {
+        Name => 'TargetPrinter',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+    },
     0x152 => {
         Name => 'ExtraSamples',
@@ -732,4 +980,5 @@
         Name => 'SampleFormat',
         Notes => 'SamplesPerPixel values',
+        WriteGroup => 'SubIFD', # (only for Validate)
         PrintConvColumns => 2,
         PrintConv => [ \%sampleFormat, \%sampleFormat, \%sampleFormat, \%sampleFormat ],
@@ -765,4 +1014,5 @@
             DirName => 'GlobParamIFD',
             Start => '$val',
+            MaxSubdirs => 1,
         },
     },
@@ -818,5 +1068,5 @@
             Notes => q{
                 ThumbnailOffset in IFD1 of JPEG and some TIFF-based images, IFD0 of MRW
-                images and AVI videos, and the SubIFD in IFD1 of SRW images;
+                images and AVI and MOV videos, and the SubIFD in IFD1 of SRW images;
                 PreviewImageStart in MakerNotes and IFD0 of ARW and SR2 images;
                 JpgFromRawStart in SubIFD of NEF images and IFD2 of PEF images; and
@@ -824,8 +1074,12 @@
             },
             # thumbnail is found in IFD1 of JPEG and TIFF images, and
-            # IFD0 of EXIF information in FujiFilm AVI (RIFF) videos
+            # IFD0 of EXIF information in FujiFilm AVI (RIFF) and MOV videos
             Condition => q{
+                # recognize NRW file from a JPEG-compressed thumbnail in IFD0
+                if ($$self{TIFF_TYPE} eq 'NEF' and $$self{DIR_NAME} eq 'IFD0' and $$self{Compression} == 6) {
+                    $self->OverrideFileType($$self{TIFF_TYPE} = 'NRW');
+                }
                 $$self{DIR_NAME} eq 'IFD1' or
-                ($$self{FILE_TYPE} eq 'RIFF' and $$self{DIR_NAME} eq 'IFD0')
+                ($$self{DIR_NAME} eq 'IFD0' and $$self{FILE_TYPE} =~ /^(RIFF|MOV)$/)
             },
             IsOffset => 1,
@@ -838,5 +1092,5 @@
             # use IFD1 for a JPEG-compressed thumbnail:  CR2, ARW, SR2 and PEF.
             # (SRF also stores a JPEG image in IFD1, but it is actually a preview
-            # and we don't yet write SRF anyway) 
+            # and we don't yet write SRF anyway)
             WriteCondition => q{
                 $$self{FILE_TYPE} ne "TIFF" or
@@ -848,5 +1102,6 @@
             Name => 'ThumbnailOffset',
             # thumbnail in IFD0 of MRW images (Minolta A200)
-            Condition => '$$self{DIR_NAME} eq "IFD0" and $$self{TIFF_TYPE} eq "MRW"',
+            # and IFD0 of NRW images (Nikon Coolpix P6000,P7000,P7100)
+            Condition => '$$self{DIR_NAME} eq "IFD0" and $$self{TIFF_TYPE} =~ /^(MRW|NRW)$/',
             IsOffset => 1,
             OffsetPair => 0x202,
@@ -856,6 +1111,6 @@
             Writable => 'int32u',
             WriteGroup => 'IFD0',
-            WriteCondition => '$$self{FILE_TYPE} eq "MRW"',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -871,6 +1126,6 @@
             Writable => 'int32u',
             WriteGroup => 'SubIFD',
-            WriteCondition => '$$self{TIFF_TYPE} eq "SRW"',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -882,6 +1137,6 @@
             Writable => 'int32u',
             WriteGroup => 'MakerNotes',
-            # (no WriteCondition necessary because MakerNotes won't be created)
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -894,6 +1149,6 @@
             Writable => 'int32u',
             WriteGroup => 'IFD0',
-            WriteCondition => '$$self{TIFF_TYPE} =~ /^(ARW|SR2)$/',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -906,6 +1161,6 @@
             WriteGroup => 'SubIFD',
             # JpgFromRaw is in SubIFD of NEF, NRW and SRW files
-            WriteCondition => '$$self{TIFF_TYPE} =~ /^(NEF|NRW|SRW)$/',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -918,6 +1173,28 @@
             WriteGroup => 'IFD2',
             # JpgFromRaw is in IFD2 of PEF files
-            WriteCondition => '$$self{TIFF_TYPE} eq "PEF"',
             Protected => 2,
+            Permanent => 1,
+        },
+        {
+            Name => 'OtherImageStart',
+            Condition => '$$self{DIR_NAME} eq "SubIFD1"',
+            IsOffset => 1,
+            OffsetPair => 0x202,
+            DataTag => 'OtherImage',
+            Writable => 'int32u',
+            WriteGroup => 'SubIFD1',
+            Protected => 2,
+            Permanent => 1,
+        },
+        {
+            Name => 'OtherImageStart',
+            Condition => '$$self{DIR_NAME} eq "SubIFD2"',
+            IsOffset => 1,
+            OffsetPair => 0x202,
+            DataTag => 'OtherImage',
+            Writable => 'int32u',
+            WriteGroup => 'SubIFD2',
+            Protected => 2,
+            Permanent => 1,
         },
         {
@@ -932,5 +1209,5 @@
             Notes => q{
                 ThumbnailLength in IFD1 of JPEG and some TIFF-based images, IFD0 of MRW
-                images and AVI videos, and the SubIFD in IFD1 of SRW images;
+                images and AVI and MOV videos, and the SubIFD in IFD1 of SRW images;
                 PreviewImageLength in MakerNotes and IFD0 of ARW and SR2 images;
                 JpgFromRawLength in SubIFD of NEF images, and IFD2 of PEF images; and
@@ -939,5 +1216,5 @@
             Condition => q{
                 $$self{DIR_NAME} eq 'IFD1' or
-                ($$self{FILE_TYPE} eq 'RIFF' and $$self{DIR_NAME} eq 'IFD0')
+                ($$self{DIR_NAME} eq 'IFD0' and $$self{FILE_TYPE} =~ /^(RIFF|MOV)$/)
             },
             OffsetPair => 0x201,
@@ -954,11 +1231,12 @@
             Name => 'ThumbnailLength',
             # thumbnail in IFD0 of MRW images (Minolta A200)
-            Condition => '$$self{DIR_NAME} eq "IFD0" and $$self{TIFF_TYPE} eq "MRW"',
+            # and IFD0 of NRW images (Nikon Coolpix P6000,P7000,P7100)
+            Condition => '$$self{DIR_NAME} eq "IFD0" and $$self{TIFF_TYPE} =~ /^(MRW|NRW)$/',
             OffsetPair => 0x201,
             DataTag => 'ThumbnailImage',
             Writable => 'int32u',
             WriteGroup => 'IFD0',
-            WriteCondition => '$$self{FILE_TYPE} eq "MRW"',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -973,6 +1251,6 @@
             Writable => 'int32u',
             WriteGroup => 'SubIFD',
-            WriteCondition => '$$self{TIFF_TYPE} eq "SRW"',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -983,6 +1261,6 @@
             Writable => 'int32u',
             WriteGroup => 'MakerNotes',
-            # (no WriteCondition necessary because MakerNotes won't be created)
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -994,6 +1272,6 @@
             Writable => 'int32u',
             WriteGroup => 'IFD0',
-            WriteCondition => '$$self{TIFF_TYPE} =~ /^(ARW|SR2)$/',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -1004,6 +1282,6 @@
             Writable => 'int32u',
             WriteGroup => 'SubIFD',
-            WriteCondition => '$$self{TIFF_TYPE} =~ /^(NEF|NRW|SRW)$/',
             Protected => 2,
+            Permanent => 1,
         },
         {
@@ -1014,6 +1292,26 @@
             Writable => 'int32u',
             WriteGroup => 'IFD2',
-            WriteCondition => '$$self{TIFF_TYPE} eq "PEF"',
             Protected => 2,
+            Permanent => 1,
+        },
+        {
+            Name => 'OtherImageLength',
+            Condition => '$$self{DIR_NAME} eq "SubIFD1"',
+            OffsetPair => 0x201,
+            DataTag => 'OtherImage',
+            Writable => 'int32u',
+            WriteGroup => 'SubIFD1',
+            Protected => 2,
+            Permanent => 1,
+        },
+        {
+            Name => 'OtherImageLength',
+            Condition => '$$self{DIR_NAME} eq "SubIFD2"',
+            OffsetPair => 0x201,
+            DataTag => 'OtherImage',
+            Writable => 'int32u',
+            WriteGroup => 'SubIFD2',
+            Protected => 2,
+            Permanent => 1,
         },
         {
@@ -1045,8 +1343,16 @@
     0x211 => {
         Name => 'YCbCrCoefficients',
+        Protected => 1,
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => 3,
         Priority => 0,
     },
     0x212 => {
         Name => 'YCbCrSubSampling',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Count => 2,
         PrintConvColumns => 2,
         PrintConv => \%Image::ExifTool::JPEG::yCbCrSubSampling,
@@ -1055,4 +1361,8 @@
     0x213 => {
         Name => 'YCbCrPositioning',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Mandatory => 1,
         PrintConv => {
             1 => 'Centered',
